base_dir = File.dirname(File.dirname(File.expand_path(__FILE__)))
$LOAD_PATH.push(base_dir)

require 'chapter_2/03-05.rb'

class HashTable
  BIN_SIZE = 4

  def initialize
    @bins = Array.new(BIN_SIZE) do |i|
      List.new
    end

    @keys = List.new # keyの順序を保存するためのリスト
  end

  def set(key, value)
    index = key.hash % BIN_SIZE
    bin = @bins[index]

    bin.each do |pair|
      if pair[0] == key
        pair[1] = value
        return self
      end
    end

    bin.unshift([key, value])
    @keys.unshift(key) # keyの順序を保存する
    self
  end

  def get(key)
    index = key.hash % BIN_SIZE
    bin = @bins[index]

    bin.each do |pair|
      if pair[0] == key
        return pair[1]
      end
    end

    nil
  end

  def each
    @keys.each do |key|
      value = self.get(key)
      yield key, value
    end
  end
end

# ハッシュテーブルを用意する
hash = HashTable.new
hash.set("foo", "bar")
hash.set("hoge", "fuga")

# ハッシュテーブルから値を得る
p hash.get("foo") # => "bar"
p hash.get("hoge") # => "fuga"

# 追加した順序で処理する
hash.each do |key, value|
  p key
  p value
end
